LibreOffice: osl/conditn.h File Reference

LibreOffice LibreOffice 6.1 SDK C/C++ API Reference

Typedefs | Enumerations | Functions
conditn.h File Reference
`#include "sal/config.h"`
`#include "osl/time.h"`
`#include "sal/saldllapi.h"`

Go to the source code of this file.

## Typedefs
typedef void * | oslCondition

## Enumerations
enum | oslConditionResult { osl_cond_result_ok, osl_cond_result_error, osl_cond_result_timeout, osl_cond_result_FORCE_EQUAL_SIZE = SAL_MAX_ENUM }

## Functions
SAL_DLLPUBLIC oslCondition | osl_createCondition (void)
| Creates a condition. More...
SAL_DLLPUBLIC void | osl_destroyCondition (oslCondition Condition)
| Free the memory used by the condition. More...
SAL_DLLPUBLIC sal_Bool | osl_setCondition (oslCondition Condition)
| Sets condition to True => wait() will not block, check() returns True. More...
SAL_DLLPUBLIC sal_Bool | osl_resetCondition (oslCondition Condition)
| Sets condition to False => wait() will block, check() returns False. More...
SAL_DLLPUBLIC oslConditionResult | osl_waitCondition (oslCondition Condition, const TimeValue *pTimeout)
| Blocks if condition is not set. More...
SAL_DLLPUBLIC sal_Bool | osl_checkCondition (oslCondition Condition)
| Queries the state of the condition without blocking. More...

## Typedef Documentation

## ◆ oslCondition

typedef void* oslCondition

## Enumeration Type Documentation

## ◆ oslConditionResult

enum oslConditionResult

Enumerator
osl_cond_result_ok |
osl_cond_result_error |
osl_cond_result_timeout |
osl_cond_result_FORCE_EQUAL_SIZE |

## Function Documentation

## ◆ osl_checkCondition()

SAL_DLLPUBLIC sal_Bool osl_checkCondition | ( | oslCondition | Condition | ) |

Queries the state of the condition without blocking.

Parameters

  Condition | handle to a created condition.

Return values

  True | condition is set
  False | condition is not set

## ◆ osl_createCondition()

SAL_DLLPUBLIC oslCondition osl_createCondition | ( | void |  | ) |

Creates a condition.

Deprecated:
  use C++11's std::condition_variable instead for a more robust and helpful condition.

The condition is in the reset-state.

Return values

  osl_cond_result_error | Condition could not be created.

## ◆ osl_destroyCondition()

SAL_DLLPUBLIC void osl_destroyCondition | ( | oslCondition | Condition | ) |

Free the memory used by the condition.

Parameters

  Condition | the condition handle.

## ◆ osl_resetCondition()

SAL_DLLPUBLIC sal_Bool osl_resetCondition | ( | oslCondition | Condition | ) |

Sets condition to False => wait() will block, check() returns False.

Parameters

  Condition | handle to a created condition.

Return values

  False | if system-call failed.

## ◆ osl_setCondition()

SAL_DLLPUBLIC sal_Bool osl_setCondition | ( | oslCondition | Condition | ) |

Sets condition to True => wait() will not block, check() returns True.

Attention
  all threads waiting on this condition are unblocked!

Parameters

  Condition | handle to a created condition.

Return values

  False | if system-call failed.

## ◆ osl_waitCondition()

SAL_DLLPUBLIC oslConditionResult osl_waitCondition | ( | oslCondition | Condition,
|  | const TimeValue * | pTimeout
| ) |  |

Blocks if condition is not set.

Parameters

  Condition | handle to a created condition.
  pTimeout | Timeout value or NULL for infinite waiting

Return values

  False | Condition has been destroyed prematurely or system call has failed.